all: main1 main2 liblittle.so testLittle main3

main1: main1.c
	gcc -c main1.c
	ld main1.o -o main1

main2: main2.c
	gcc -c main2.c
	ld main2.o -o main2 -Tls_main2

main3: main3.c
	gcc -ffreestanding -fno-builtin main3.c -o main3 -llittle -L.

liblittle.so: little.h little.c
	gcc -c -fPIC little.c -o little.o    
	gcc -shared -Wl,-soname,liblittle.so.1 -o liblittle.so  little.o
	ln -s liblittle.so liblittle.so.1

testLittle: testLittle.c liblittle.so
	gcc testLittle.c -llittle -L. -o testLittle
	
runTestLittle: testLittle
	./testLittle

clean:
	rm -fr *.o
	rm -fr main1 main2 main3
	rm -fr liblittle.so*
